Index: trunk/examples/extended/electromagnetic/TestEm12/include/DetectorConstruction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/DetectorConstruction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/DetectorConstruction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.hh,v 1.2 2006/06/29 16:42:01 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/DetectorMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/DetectorMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/DetectorMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.hh,v 1.2 2006/06/29 16:42:03 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/EventAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/EventAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/EventAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.hh,v 1.2 2006/06/29 16:42:06 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/EventActionMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/EventActionMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/EventActionMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.hh,v 1.2 2006/06/29 16:42:08 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/HistoManager.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/HistoManager.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/HistoManager.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoManager.hh,v 1.6 2007/11/09 17:35:06 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/HistoMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/HistoMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/HistoMessenger.hh	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoMessenger.hh,v 1.3 2007/11/09 17:35:06 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: HistoMessenger.hh,v 1.4 2008/01/11 13:11:31 jjacquem Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -63,4 +63,5 @@
    G4UIcmdWithAString*        factoryCmd;
    G4UIcmdWithAString*        typeCmd;
+   G4UIcmdWithAString*        optionCmd;
    G4UIcommand*               histoCmd;
    G4UIcmdWithAnInteger*      prhistoCmd;   
Index: trunk/examples/extended/electromagnetic/TestEm12/include/PhysListEmStandard.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/PhysListEmStandard.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/PhysListEmStandard.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysListEmStandard.hh,v 1.2 2006/06/29 16:42:25 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/PhysicsList.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/PhysicsList.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/PhysicsList.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysicsList.hh,v 1.3 2006/06/29 16:42:37 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/PhysicsListMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/PhysicsListMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/PhysicsListMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysicsListMessenger.hh,v 1.2 2006/06/29 16:42:40 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/PrimaryGeneratorAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/PrimaryGeneratorAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/PrimaryGeneratorAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.hh,v 1.2 2006/06/29 16:42:42 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/PrimaryGeneratorMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/PrimaryGeneratorMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/PrimaryGeneratorMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorMessenger.hh,v 1.2 2006/06/29 16:42:44 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/RunAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/RunAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/RunAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: RunAction.hh,v 1.4 2007/04/27 10:38:11 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/StepMax.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/StepMax.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/StepMax.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.hh,v 1.3 2006/06/29 16:42:50 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/StepMaxMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/StepMaxMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/StepMaxMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.hh,v 1.3 2006/06/29 16:42:52 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/SteppingAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/SteppingAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/SteppingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.hh,v 1.2 2006/06/29 16:42:54 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/SteppingVerbose.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/SteppingVerbose.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/SteppingVerbose.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingVerbose.hh,v 1.2 2006/06/29 16:42:56 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/include/TrackingAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/include/TrackingAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/include/TrackingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TrackingAction.hh,v 1.2 2006/06/29 16:42:58 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/run01.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/run01.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/run01.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: run01.mac,v 1.6 2007/04/27 10:38:11 maire Exp $
+# $Id: run01.mac,v 1.7 2009/09/22 15:18:20 maire Exp $
 #
 # limit the step size from histos 1 and 8
@@ -9,7 +9,7 @@
 /testem/det/setRadius  3 cm
 #
-/testem/phys/addPhysics  standard	# em physics
-###/testem/phys/addPhysics  livermore	# em physics
-###/testem/phys/addPhysics  penelope	# em physics
+/testem/phys/addPhysics  local	# em physics
+###/testem/phys/addPhysics  emlivermore	# em physics
+###/testem/phys/addPhysics  empenelope	# em physics
 #
 /run/initialize
Index: trunk/examples/extended/electromagnetic/TestEm12/run02.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/run02.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/run02.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: run02.mac,v 1.5 2007/04/27 10:38:11 maire Exp $
+# $Id: run02.mac,v 1.6 2009/09/22 15:18:20 maire Exp $
 #
 # limit the step size by geometry
@@ -10,7 +10,7 @@
 /testem/det/setNbOfLayers 150
 #
-/testem/phys/addPhysics  standard	# em physics
-###/testem/phys/addPhysics  livermore  	# em physics
-###/testem/phys/addPhysics  penelope  	# em physics 
+/testem/phys/addPhysics  local	# em physics
+###/testem/phys/addPhysics  emlivermore  	# em physics
+###/testem/phys/addPhysics  empenelope  	# em physics 
 #
 /run/initialize
Index: trunk/examples/extended/electromagnetic/TestEm12/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/DetectorConstruction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.cc,v 1.2 2006/06/29 16:43:00 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/DetectorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/DetectorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.2 2006/06/29 16:43:03 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/EventAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/EventAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/EventAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.cc,v 1.2 2006/06/29 16:43:05 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/EventActionMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/EventActionMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/EventActionMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.cc,v 1.2 2006/06/29 16:43:07 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/HistoManager.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/HistoManager.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/HistoManager.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoManager.cc,v 1.6 2007/11/09 17:35:06 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: HistoManager.cc,v 1.11 2008/09/23 20:48:12 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -54,6 +54,6 @@
  
   fileName[0] = "testem12";
-  fileType    = "hbook";
-  fileOption  = "--noErrors uncompress";  
+  fileType    = "root";
+  fileOption  = "--noErrors export=root uncompress";  
   // histograms
   for (G4int k=0; k<MaxHisto; k++) {
@@ -224,5 +224,5 @@
  if (ih > MaxHisto) {
     G4cout << "---> warning from HistoManager::RemoveHisto() : histo " << ih
-           << "does not exist" << G4endl;
+           << "does not exist  (fac = " << fac << ")"  << G4endl;
     return;
   }
@@ -236,5 +236,5 @@
 void HistoManager::PrintHisto(G4int ih)
 {
- if (ih < MaxHisto) ascii[ih] = true;
+ if (ih < MaxHisto) { ascii[ih] = true; ascii[0] = true; }
  else
     G4cout << "---> warning from HistoManager::PrintHisto() : histo " << ih
@@ -249,5 +249,7 @@
 {
 #ifdef G4ANALYSIS_USE
- 
+
+ if (!ascii[0] ) return;
+  
  G4String name = fileName[0] + ".ascii";
  std::ofstream File(name, std::ios::out);
@@ -262,5 +264,6 @@
       for (G4int iBin=0; iBin<Nbins[ih]; iBin++) {
          File << "  " << iBin << "\t" 
-              << histo[ih]->binMean(iBin) << "\t"
+              << 0.5*(histo[ih]->axis().binLowerEdge(iBin) +
+	              histo[ih]->axis().binUpperEdge(iBin)) << "\t"	      
 	      << histo[ih]->binHeight(iBin) 
 	      << G4endl;
Index: trunk/examples/extended/electromagnetic/TestEm12/src/HistoMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/HistoMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/HistoMessenger.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoMessenger.cc,v 1.4 2007/11/09 17:35:06 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: HistoMessenger.cc,v 1.5 2008/01/11 13:11:31 jjacquem Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -56,4 +56,8 @@
   typeCmd->SetGuidance("set histograms file type: hbook, root, XML");
   typeCmd->SetCandidates("hbook root XML");
+
+  optionCmd = new G4UIcmdWithAString("/testem/histo/setFileOption",this);
+  optionCmd->SetGuidance("set option for the histograms file");
+
 
   histoCmd = new G4UIcommand("/testem/histo/setHisto",this);
@@ -112,4 +116,5 @@
   delete factoryCmd;
   delete histoDir;
+  delete optionCmd;
 }
 
@@ -123,4 +128,9 @@
   if (command == typeCmd)
     histoManager->SetFileType(newValues);
+
+  if (command == optionCmd)
+    histoManager->SetFileOption(newValues);
+
+
 
   if (command == histoCmd)
Index: trunk/examples/extended/electromagnetic/TestEm12/src/PhysListEmStandard.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/PhysListEmStandard.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/PhysListEmStandard.cc	(revision 1230)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: PhysListEmStandard.cc,v 1.2 2006/06/29 16:43:25 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysListEmStandard.cc,v 1.8 2009/11/16 16:18:27 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -39,16 +38,26 @@
 #include "G4PhotoElectricEffect.hh"
 
-#include "G4MultipleScattering.hh"
-
+#include "G4eMultipleScattering.hh"
+#include "G4UrbanMscModel93.hh"
 #include "G4eIonisation.hh"
 #include "G4eBremsstrahlung.hh"
 #include "G4eplusAnnihilation.hh"
 
+#include "G4MuMultipleScattering.hh"
 #include "G4MuIonisation.hh"
 #include "G4MuBremsstrahlung.hh"
 #include "G4MuPairProduction.hh"
 
+#include "G4hMultipleScattering.hh"
 #include "G4hIonisation.hh"
+#include "G4hBremsstrahlung.hh"
+#include "G4hPairProduction.hh"
+
 #include "G4ionIonisation.hh"
+#include "G4IonParametrisedLossModel.hh"
+#include "G4NuclearStopping.hh"
+
+#include "G4EmProcessOptions.hh"
+#include "G4MscStepLimitType.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -68,4 +77,5 @@
 {
   // Add standard EM Processes
+  //
 
   theParticleIterator->reset();
@@ -76,5 +86,5 @@
      
     if (particleName == "gamma") {
-      // gamma         
+      // gamma
       pmanager->AddDiscreteProcess(new G4PhotoElectricEffect);
       pmanager->AddDiscreteProcess(new G4ComptonScattering);
@@ -83,35 +93,90 @@
     } else if (particleName == "e-") {
       //electron
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4eIonisation,        -1, 2,2);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 3,3);
+      G4eMultipleScattering* msc = new G4eMultipleScattering();
+      msc->AddEmModel(0, new G4UrbanMscModel93());
+      pmanager->AddProcess(msc,                       -1, 1, 1);      
+      pmanager->AddProcess(new G4eIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4eBremsstrahlung,     -1, 3, 3);
 	    
     } else if (particleName == "e+") {
       //positron
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4eIonisation,        -1, 2,2);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 3,3);
-      pmanager->AddProcess(new G4eplusAnnihilation,   0,-1,4);
-      
-    } else if( particleName == "mu+" || 
+      G4eMultipleScattering* msc = new G4eMultipleScattering();
+      msc->AddEmModel(0, new G4UrbanMscModel93());
+      pmanager->AddProcess(msc,                       -1, 1, 1);            
+      pmanager->AddProcess(new G4eIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4eBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4eplusAnnihilation,    0,-1, 4);
+            
+    } else if (particleName == "mu+" || 
                particleName == "mu-"    ) {
       //muon  
-      pmanager->AddProcess(new G4MultipleScattering,-1, 1,1);
-      pmanager->AddProcess(new G4MuIonisation,      -1, 2,2);
-      pmanager->AddProcess(new G4MuBremsstrahlung,  -1, 3,3);
-      pmanager->AddProcess(new G4MuPairProduction,  -1, 4,4);       
+      pmanager->AddProcess(new G4MuMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4MuIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4MuBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4MuPairProduction,     -1, 4, 4);
+             
+    } else if( particleName == "proton" ||
+               particleName == "pi-" ||
+               particleName == "pi+"    ) {
+      //proton  
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4hBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4hPairProduction,     -1, 4, 4);       
      
-    } else if( particleName == "GenericIon" ) { 
-      pmanager->AddProcess(new G4MultipleScattering,-1, 1,1);
-      pmanager->AddProcess(new G4ionIonisation,     -1, 2,2);
-
+    } else if( particleName == "alpha" || 
+	       particleName == "He3"    ) {
+      //alpha 
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4ionIonisation,       -1, 2, 2);
+      pmanager->AddProcess(new G4NuclearStopping,     -1, 3,-1);
+            
+    } else if( particleName == "GenericIon" ) {
+      //Ions 
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      G4ionIonisation* ionIoni = new G4ionIonisation();
+      ionIoni->SetEmModel(new G4IonParametrisedLossModel());
+      pmanager->AddProcess(ionIoni,                   -1, 2, 2);      
+      pmanager->AddProcess(new G4NuclearStopping,     -1, 3,-1);      
+      
     } else if ((!particle->IsShortLived()) &&
 	       (particle->GetPDGCharge() != 0.0) && 
 	       (particle->GetParticleName() != "chargedgeantino")) {
       //all others charged particles except geantino
-      pmanager->AddProcess(new G4MultipleScattering,-1,1,1);
-      pmanager->AddProcess(new G4hIonisation,       -1,2,2);
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,         -1, 2, 2);
     }
   }
+
+  // Em options
+  //
+  // Main options and setting parameters are shown here.
+  // Several of them have default values.
+  //
+  G4EmProcessOptions emOptions;
+  
+  //physics tables
+  //
+  emOptions.SetMinEnergy(100*eV);	//default    
+  emOptions.SetMaxEnergy(100*TeV);	//default  
+  emOptions.SetDEDXBinning(12*20);	//default=12*7
+  emOptions.SetLambdaBinning(12*20);	//default=12*7
+  emOptions.SetSplineFlag(true);	//default
+      
+  //multiple coulomb scattering
+  //
+  emOptions.SetMscStepLimitation(fUseDistanceToBoundary);  //default=fUseSafety
+  emOptions.SetMscRangeFactor(0.04);	//default
+  emOptions.SetMscGeomFactor (2.5);	//default       
+  emOptions.SetSkin(3.);		//default
+      
+  //energy loss
+  //
+  emOptions.SetStepFunction(0.2, 100*um);	//default=(0.2, 1*mm)   
+  emOptions.SetLinearLossLimit(1.e-2);		//default
+   
+  //ionization
+  //
+  emOptions.SetSubCutoff(false);	//default
 }
 
Index: trunk/examples/extended/electromagnetic/TestEm12/src/PhysicsList.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/PhysicsList.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/PhysicsList.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: PhysicsList.cc,v 1.6 2007/08/19 20:57:28 maire Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysicsList.cc,v 1.8 2009/09/22 15:18:20 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -34,6 +34,11 @@
 
 #include "PhysListEmStandard.hh"
-#include "PhysListEmLivermore.hh"
-#include "PhysListEmPenelope.hh"
+
+#include "G4EmStandardPhysics.hh"
+#include "G4EmStandardPhysics_option1.hh"
+#include "G4EmStandardPhysics_option2.hh"
+#include "G4EmStandardPhysics_option3.hh"
+#include "G4EmLivermorePhysics.hh"
+#include "G4EmPenelopePhysics.hh"
 
 #include "G4LossTableManager.hh"
@@ -57,5 +62,5 @@
 
   // EM physics
-  emPhysicsList = new PhysListEmStandard(emName = "standard");
+  emPhysicsList = new PhysListEmStandard(emName = "local");
 
 }
@@ -186,5 +191,6 @@
   G4EmProcessOptions emOptions;
   emOptions.SetBuildCSDARange(true);
-  
+  emOptions.SetDEDXBinningForCSDARange(8*20);
+    
   // decay process
   //
@@ -206,5 +212,5 @@
   if (name == emName) return;
 
-  if (name == "standard") {
+  if (name == "local") {
 
     emName = name;
@@ -212,15 +218,38 @@
     emPhysicsList = new PhysListEmStandard(name);
     
-  } else if (name == "livermore") {
-
-    emName = name;
-    delete emPhysicsList;
-    emPhysicsList = new PhysListEmLivermore(name);
+  } else if (name == "emstandard_opt0") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics();
     
-  } else if (name == "penelope") {
-
-    emName = name;
-    delete emPhysicsList;
-    emPhysicsList = new PhysListEmPenelope(name);
+  } else if (name == "emstandard_opt1") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics_option1();
+
+  } else if (name == "emstandard_opt2") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics_option2();
+        
+  } else if (name == "emstandard_opt3") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics_option3();
+            
+  } else if (name == "emlivermore") {
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmLivermorePhysics();
+    
+  } else if (name == "empenelope") {
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmPenelopePhysics();
+
      
   } else {
Index: trunk/examples/extended/electromagnetic/TestEm12/src/PhysicsListMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/PhysicsListMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/PhysicsListMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysicsListMessenger.cc,v 1.2 2006/06/29 16:43:30 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/PrimaryGeneratorAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/PrimaryGeneratorAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/PrimaryGeneratorAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.cc,v 1.2 2006/06/29 16:43:32 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/PrimaryGeneratorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/PrimaryGeneratorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/PrimaryGeneratorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorMessenger.cc,v 1.2 2006/06/29 16:43:34 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/RunAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/RunAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/RunAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: RunAction.cc,v 1.8 2007/08/19 20:57:29 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/StepMax.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/StepMax.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/StepMax.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.cc,v 1.3 2006/06/29 16:43:38 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/StepMaxMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/StepMaxMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/StepMaxMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.cc,v 1.3 2006/06/29 16:43:40 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/SteppingAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/SteppingAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/SteppingAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.cc,v 1.4 2007/04/27 10:38:11 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm12/src/SteppingVerbose.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/src/SteppingVerbose.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/src/SteppingVerbose.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingVerbose.cc,v 1.2 2006/06/29 16:43:46 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
